<?php namespace Grafika\Search\Classes\Event\Product;

use Lovata\Shopaholic\Models\Product;
use Lovata\Shopaholic\Classes\Collection\ProductCollection;

/**
 * Class ExtendProductCollection
 * @package Lovata\BaseCode\Classes\Event\Product
 */
class ExtendProductCollection
{
    public function subscribe()
    {
        ProductCollection::extend(function ($obProductList) {
            $this->poisk($obProductList);
        });
    }

    /**
     * Add myCustomMethod method
     * @param ProductCollection $obProductList
     */
    protected function poisk($obProductList)
    {
    	
        $obProductList->addDynamicMethod('poisk', function ($value) use ($obProductList) {
        	
            $arResultIDList = (array) Product::where('name', 'like', '%'.$value.'%')->lists('id');

            return $obProductList->intersect($arResultIDList);
        });
    }
}